local ENABLE_ANIMATION = aio_double_tap_run.settings.animations
local SPRINT_FRAMESPEED = aio_double_tap_run.settings.sprint_speed
local WALK_FRAMESPEED = aio_double_tap_run.settings.walk_speed
local IDLE_FRAMESPEED = aio_double_tap_run.settings.idle_speed or 15 -- Add this to your settings
local PUNCH_FRAMESPEED = aio_double_tap_run.settings.punch_speed or 30 -- Add this to your settings

aio_double_tap_run.register_callback(function(player, data, dtime)
    local player_name = player:get_player_name()
    if not ENABLE_ANIMATION then return end

    local current_animation = player:get_animation()
    local animation_range = current_animation and { x = current_animation.x, y = current_animation.y } or { x = 0, y = 79 }
    local velocity = player:get_velocity()
    local speed = (velocity.x^2 + velocity.z^2)^0.5

    if data.is_sprinting then
        local sprint_speed = SPRINT_FRAMESPEED + speed * 2
        player:set_animation(animation_range, sprint_speed, 0)
    else
        -- Detect animation type
        if current_animation and current_animation.x == 0 and current_animation.y == 79 then
            -- Idle animation (example range, adjust as needed)
            player:set_animation(animation_range, IDLE_FRAMESPEED, 0)
        elseif current_animation and current_animation.x == 189 and current_animation.y == 198 then
            -- Punch/mine animation (example range, adjust as needed)
            player:set_animation(animation_range, PUNCH_FRAMESPEED, 0)
        else
            -- Walking or other animation
            local walk_speed = WALK_FRAMESPEED + speed * 2
            player:set_animation(animation_range, walk_speed, 0)
        end
    end
end)
